/**
 * Copyright IRAP (CNRS/UPS/CNES)
 * 
 * The complete list of authors can be seen on CASSIS website at
 * the following URL "http://cassis.irap.omp.eu/?page=authors".
 * 
 * This software is a computer program whose purpose is to display, analyze
 * and create model of astrophysical spectra. It allow to use database and
 * related virtual observatory tools.
 * 
 * This software is governed by the CeCILL license under French law and
 * abiding by the rules of distribution of free software.  You can  use, 
 * modify and/ or redistribute the software under the terms of the CeCILL
 * license as circulated by CEA, CNRS and INRIA at the following URL
 * "http://www.cecill.info". 
 * 
 * As a counterpart to the access to the source code and  rights to copy,
 * modify and redistribute granted by the license, users are provided only
 * with a limited warranty  and the software's author,  the holder of the
 * economic rights,  and the successive licensors  have only  limited
 * liability. 
 * 
 * In this respect, the user's attention is drawn to the risks associated
 * with loading,  using,  modifying and/or developing or reproducing the
 * software by the user in light of its specific status of free software,
 * that may mean  that it is complicated to manipulate,  and  that  also
 * therefore means  that it is reserved for developers  and  experienced
 * professionals having in-depth computer knowledge. Users are therefore
 * encouraged to load and test the software's suitability as regards their
 * requirements in conditions enabling the security of their systems and/or 
 * data to be ensured and,  more generally, to use and operate it in the 
 * same conditions as regards security. 
 * 
 * The fact that you are presently reading this means that you have had
 * knowledge of the CeCILL license and that you accept its terms.
 */

//package eu.omp.irap.cassis.gui.plot.series;
//
//import java.awt.Graphics2D;
//import java.awt.Paint;
//import java.awt.Stroke;
//import java.awt.geom.Line2D;
//import java.awt.geom.Rectangle2D;
//import java.io.IOException;
//import java.io.ObjectInputStream;
//import java.io.ObjectOutputStream;
//
//import org.jfree.chart.axis.ValueAxis;
//import org.jfree.chart.event.RendererChangeEvent;
//import org.jfree.chart.plot.CrosshairState;
//import org.jfree.chart.plot.PlotOrientation;
//import org.jfree.chart.plot.PlotRenderingInfo;
//import org.jfree.chart.plot.XYPlot;
//import org.jfree.chart.renderer.xy.XYItemRendererState;
//import org.jfree.chart.renderer.xy.XYLineAndShapeRenderer;
//import org.jfree.data.Range;
//import org.jfree.data.xy.IntervalXYDataset;
//import org.jfree.data.xy.XYDataset;
//import org.jfree.io.SerialUtilities;
//import org.jfree.ui.RectangleEdge;
//import org.jfree.util.ObjectUtilities;
//import org.jfree.util.PaintUtilities;
//
//import eu.omp.irap.cassis.gui.plot.simple.collection.SeriesCassisCollection;
//
//public class ErrorCassisRenderer extends XYLineAndShapeRenderer {
//
//    /** For serialization. */
//    static final long serialVersionUID = 5162283570955172424L;
//
//    /** A flag that controls whether or not the x-error bars are drawn. */
//    private boolean drawXError;
//
//    /** A flag that controls whether or not the y-error bars are drawn. */
//    private boolean drawYError;
//
//    /** The length of the cap at the end of the error bars. */
//    private double capLength;
//
//    /**
//     * The paint used to draw the error bars (if <code>null</code> we use the
//     * series paint).
//     */
//    private transient Paint errorPaint;
//
//    /**
//     * The stroke used to draw the error bars (if <code>null</code> we use the
//     * series outline stroke).
//     *
//     * @since 1.0.13
//     */
//    private transient Stroke errorStroke;
//
//    /**
//     * Creates a new <code>ErrorCassisRenderer</code> instance.
//     */
//    public ErrorCassisRenderer() {
//        super(false, true);
//        this.drawYError = true;
//        this.errorPaint = null;
//        this.errorStroke = null;
//        this.capLength = 4.0;
//    }
//
//    /**
//     * Returns the flag that controls whether or not the renderer draws error
//     * bars for the y-values.
//     *
//     * @return A boolean.
//     *
//     * @see #setDrawYError(boolean)
//     */
//    public boolean getDrawYError() {
//        return this.drawYError;
//    }
//
//    /**
//     * Sets the flag that controls whether or not the renderer draws error
//     * bars for the y-values and, if the flag changes, sends a
//     * {@link RendererChangeEvent} to all registered listeners.
//     *
//     * @param draw  the flag value.
//     *
//     * @see #getDrawYError()
//     */
//    public void setDrawYError(boolean draw) {
//        if (this.drawYError != draw) {
//            this.drawYError = draw;
//            fireChangeEvent();
//        }
//    }
//
//    /**
//     * Returns the length (in Java2D units) of the cap at the end of the error
//     * bars.
//     *
//     * @return The cap length.
//     *
//     * @see #setCapLength(double)
//     */
//    public double getCapLength() {
//        return this.capLength;
//    }
//
//    /**
//     * Sets the length of the cap at the end of the error bars, and sends a
//     * {@link RendererChangeEvent} to all registered listeners.
//     *
//     * @param length  the length (in Java2D units).
//     *
//     * @see #getCapLength()
//     */
//    public void setCapLength(double length) {
//        this.capLength = length;
//        fireChangeEvent();
//    }
//
//    /**
//     * Returns the paint used to draw the error bars.  If this is
//     * <code>null</code> (the default), the item paint is used instead.
//     *
//     * @return The paint (possibly <code>null</code>).
//     *
//     * @see #setErrorPaint(Paint)
//     */
//    public Paint getErrorPaint() {
//        return this.errorPaint;
//    }
//
//    /**
//     * Sets the paint used to draw the error bars and sends a
//     * {@link RendererChangeEvent} to all registered listeners.
//     *
//     * @param paint  the paint (<code>null</code> permitted).
//     *
//     * @see #getErrorPaint()
//     */
//    public void setErrorPaint(Paint paint) {
//        this.errorPaint = paint;
//        fireChangeEvent();
//    }
//
//    /**
//     * Returns the stroke used to draw the error bars.  If this is 
//     * <code>null</code> (the default), the item outline stroke is used 
//     * instead.
//     * 
//     * @return The stroke (possibly <code>null</code>).
//     *
//     * @see #setErrorStroke(Stroke)
//     * 
//     * @since 1.0.13
//     */
//    public Stroke getErrorStroke() {
//        return this.errorStroke;
//    }
//
//    /**
//     * Sets the stroke used to draw the error bars and sends a
//     * {@link RendererChangeEvent} to all registered listeners.
//     *
//     * @param stroke   the stroke (<code>null</code> permitted).
//     *
//     * @see #getErrorStroke()
//     *
//     * @since 1.0.13
//     */
//    public void setErrorStroke(Stroke stroke) {
//        this.errorStroke = stroke;
//        fireChangeEvent();
//    }
//
//    /**
//     * Returns the range required by this renderer to display all the domain
//     * values in the specified dataset.
//     *
//     * @param dataset  the dataset (<code>null</code> permitted).
//     *
//     * @return The range, or <code>null</code> if the dataset is
//     *     <code>null</code>.
//     */
//    @Override
//    public Range findDomainBounds(XYDataset dataset) {
//        // include the interval if there is one
//        return findDomainBounds(dataset, true);
//    }
//
//    /**
//     * Returns the range required by this renderer to display all the range
//     * values in the specified dataset.
//     *
//     * @param dataset  the dataset (<code>null</code> permitted).
//     *
//     * @return The range, or <code>null</code> if the dataset is
//     *     <code>null</code>.
//     */
//    @Override
//    public Range findRangeBounds(XYDataset dataset) {
//        // include the interval if there is one
//        return findRangeBounds(dataset, true);
//    }
//
//    /**
//     * Draws the visual representation for one data item.
//     *
//     * @param g2  the graphics output target.
//     * @param state  the renderer state.
//     * @param dataArea  the data area.
//     * @param info  the plot rendering info.
//     * @param plot  the plot.
//     * @param domainAxis  the domain axis.
//     * @param rangeAxis  the range axis.
//     * @param dataset  the dataset.
//     * @param series  the series index.
//     * @param item  the item index.
//     * @param crosshairState  the crosshair state.
//     * @param pass  the pass index.
//     */
//    @Override
//    public void drawItem(Graphics2D g2, XYItemRendererState state,
//            Rectangle2D dataArea, PlotRenderingInfo info, XYPlot plot,
//            ValueAxis domainAxis, ValueAxis rangeAxis, XYDataset dataset,
//            int series, int item, CrosshairState crosshairState, int pass) {
//        if (pass == 0 && dataset instanceof SeriesCassisCollection
//                && getItemVisible(series, item)) {
//        	SeriesCassisCollection col = (SeriesCassisCollection) dataset;
//            PlotOrientation orientation = plot.getOrientation();
//            if (this.drawYError) {
//            	double y0 = col.getErrorYLow(series, item);
//            	double y1 = col.getErrorYHigh(series, item);
//            	if (!Double.isNaN(y0) && !Double.isNaN(y1)) {
//	            	double x = col.getXValue(series, item);
//	                RectangleEdge edge = plot.getRangeAxisEdge();
//	                double yy0 = rangeAxis.valueToJava2D(y0, dataArea, edge);
//	                double yy1 = rangeAxis.valueToJava2D(y1, dataArea, edge);
//	                double xx = domainAxis.valueToJava2D(x, dataArea,
//	                        plot.getDomainAxisEdge());
//	                Line2D line;
//	                Line2D cap1;
//	                Line2D cap2;
//	                double adj = this.capLength / 2.0;
//	                if (orientation == PlotOrientation.VERTICAL) {
//	                    line = new Line2D.Double(xx, yy0, xx, yy1);
//	                    cap1 = new Line2D.Double(xx - adj, yy0, xx + adj, yy0);
//	                    cap2 = new Line2D.Double(xx - adj, yy1, xx + adj, yy1);
//	                }
//	                else {  // PlotOrientation.HORIZONTAL
//	                    line = new Line2D.Double(yy0, xx, yy1, xx);
//	                    cap1 = new Line2D.Double(yy0, xx - adj, yy0, xx + adj);
//	                    cap2 = new Line2D.Double(yy1, xx - adj, yy1, xx + adj);
//	                }
//	                if (this.errorPaint != null) {
//	                    g2.setPaint(this.errorPaint);
//	                }
//	                else {
//	                    g2.setPaint(getItemPaint(series, item));
//	                }
//	                if (this.errorStroke != null) {
//	                    g2.setStroke(this.errorStroke);
//	                }
//	                else {
//	                    g2.setStroke(getItemStroke(series, item));
//	                }
//	                g2.draw(line);
//	                g2.draw(cap1);
//	                g2.draw(cap2);
//            	}
//            }
//        }
//        super.drawItem(g2, state, dataArea, info, plot, domainAxis, rangeAxis,
//                dataset, series, item, crosshairState, pass);
//    }
//
//    /**
//     * Tests this instance for equality with an arbitrary object.
//     *
//     * @param obj  the object (<code>null</code> permitted).
//     *
//     * @return A boolean.
//     */
//    @Override
//    public boolean equals(Object obj) {
//        if (obj == this) {
//            return true;
//        }
//        if (!(obj instanceof ErrorCassisRenderer)) {
//            return false;
//        }
//        ErrorCassisRenderer that = (ErrorCassisRenderer) obj;
//        if (this.drawXError != that.drawXError) {
//            return false;
//        }
//        if (this.drawYError != that.drawYError) {
//            return false;
//        }
//        if (this.capLength != that.capLength) {
//            return false;
//        }
//        if (!PaintUtilities.equal(this.errorPaint, that.errorPaint)) {
//            return false;
//        }
//        if (!ObjectUtilities.equal(this.errorStroke, that.errorStroke)) {
//            return false;
//        }
//        return super.equals(obj);
//    }
//
//    /**
//     * Provides serialization support.
//     *
//     * @param stream  the input stream.
//     *
//     * @throws IOException  if there is an I/O error.
//     * @throws ClassNotFoundException  if there is a classpath problem.
//     */
//    private void readObject(ObjectInputStream stream)
//            throws IOException, ClassNotFoundException {
//        stream.defaultReadObject();
//        this.errorPaint = SerialUtilities.readPaint(stream);
//        this.errorStroke = SerialUtilities.readStroke(stream);
//    }
//
//    /**
//     * Provides serialization support.
//     *
//     * @param stream  the output stream.
//     *
//     * @throws IOException  if there is an I/O error.
//     */
//    private void writeObject(ObjectOutputStream stream) throws IOException {
//        stream.defaultWriteObject();
//        SerialUtilities.writePaint(this.errorPaint, stream);
//        SerialUtilities.writeStroke(this.errorStroke, stream);
//    }
//	
//}
